#!/bin/bash
# Copyright (c) Members of the EGEE Collaboration. 2004.
# See http://www.eu-egee.org/partners/ for details on the copyright holders.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#
# Site Functioanl Test to test FTS webservice response
#
# Gavin McCance
#
# Version 0.1 - 22 Feb 2006
#

# Get the gLite environment

if [ -e /etc/glite/profile.d/glite_setenv.sh ]; then
   . /etc/glite/profile.d/glite_setenv.sh
else
   export GLITE_LOCATION=/opt/glite
   export LD_LIBRARY_PATH=/usr/local/lib:/opt/globus/lib:/opt/glite/externals/myproxy-1.14/lib/:/opt/glite/externals/lib:/opt/glite/libP:/usr/lib/oracle/10.1.0.3/client/lib:${LD_LIBRARY_PATH}
fi

# Assume we have a valid proxy

# Check the FileTransfer web-service
TRANTEST=`glite-transfer-getroles | grep "You current clientDN" | awk '{print $2}'`
if [ "${TRANTEST}" = "current" ]; then
   echo FileTransfer: OK
else
   echo FilTransfer: BAD
fi

# Check the ChannelManagement web-service
CHAN=`glite-transfer-channel-list XSFT_TEST-RANDOMX 2>&1 | awk '{print $8}'`
if [ "${CHAN}" = "exist" ]; then
   echo ChannelManagement: OK
else
   echo ChannelManagement: BAD
fi

# Check the TransferStats web-service
TRANSTATS=`glite-transfer-stats-agents  | head -1 | grep Agent | awk '{print $2}'`
if [ "$TRANSTATS" = "Agent" ]; then
   echo TransferStats: OK
else
   echo TransferStats: BAD
fi
	    
# Check the webservice's version
VERSION=`glite-transfer-channel-list -v | grep "Service version" | awk '{print $4}'`
echo Service version: ${VERSION}

