#!/usr/bin/python
# Copyright (c) Members of the EGEE Collaboration. 2004.
# See http://www.eu-egee.org/partners/ for details on the copyright holders.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Scan the FTS webservice main logfile for stacktrace problems and report
# them in a readable way.

import sys
import re

# Get logfile to parse
if len(sys.argv) == 2:
    logfile = sys.argv[1]
    print "Parsing logfile: %s" % logfile
else:
    logfile = '/usr/share/tomcat5/logs/org.glite.data'
    print "Parsing default logfile: %s" % logfile

# Look for those lovely Java stacktraces

file = open(logfile, 'r')
ppat = re.compile(r"""(?P<thetime>[0-9]{4,4}-[0-9]{2,2}-[0-9]{2,2}
                    \s[0-9]{1,2}:[0-9]{2,2}:[0-9]{2,2},[0-9]{3,3})
	    """,
                   re.IGNORECASE |
                   re.VERBOSE)
xpat = re.compile(r"""(?P<except>Exception:)
	    """, re.VERBOSE)

atpat = re.compile("at\s\w*?\.\w*?\.")
 
state='lookingforexception'
foundexcpt = { }
xlines = [ ]
for line in file:
    lasttimematch = ppat.search(line)
    if lasttimematch:
	lasttime = lasttimematch.group('thetime')
	if state=='eatingexception':
	    state='lookingforexception'
	    foundexcpt[xtime] = xlines
	    xlines = [ ]
    excepti = xpat.search(line)
    if excepti and state != 'eatingexception':
	state='eatingexception'
	xtime = lasttime
    if state == 'eatingexception':
	xlines.append(line)

for time in foundexcpt.keys():
    print "\n\nFound exception at time: " + time + "\n"
    lines = foundexcpt[time]
    for lin in lines:
	atmatch = atpat.search(lin)
	if atmatch:
	    break
	print lin.strip()
	
