#!/bin/bash 

#
# Copyright (c) Members of the EGEE Collaboration. 2004.
# See http://www.eu-egee.org/partners/ for details on the copyright holders.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
#  GLite Data Transfer Scripts
#
#  Authors: Paolo Badino <paolo.badino@cern.ch>
#  Version info: $Id: fts-2-gridview-summary.sh,v 1.2 2007/03/28 14:12:29 badino Exp $
#  Release: $Name:  $
#
#

SUMMARY_TYPE=$1
# Check that SUMMARY_TYPE is set
if [ "x$SUMMARY_TYPE" == "x" ] ; then
    echo "SUMMARY_TYPE is not set"
    exit -1;
fi

# Check that GLITE_LOCATION is set
if [ "x$GLITE_LOCATION" == "x" ] ; then
    if [ -e /etc/profile.d/gliteenv.sh ]; then
        source /etc/profile.d/gliteenv.sh
    fi
    if [ "x$GLITE_LOCATION" == "x" ] ; then
        echo "GLITE_LOCATION Environemnt variable is not set. Please fix your profile";
        exit -1;
    fi
fi

# Import Common functions
source $GLITE_LOCATION/share/glite-data-transfer-scripts/publishing/gridview/common.sh

# Publish data
gridview_summary_publishing
